﻿/** Converts numeric degrees to radians */
if (typeof (Number.prototype.toRad) === "undefined") {
    Number.prototype.toRad = function () {
        return this * Math.PI / 180;
    }
}


var sLocType = '';



function loadCities(st, type) {

    sLocType = type;

    if (st != -1) {

        var db = window.openDatabase("Garden", "1.0", "Organic Gardening", 200000);
        db.transaction(function queryGardenPlannerList(tx) {
            tx.executeSql('SELECT rowid, * FROM CityState where ST="' + st + '" ORDER BY CITY', [], returnCityDetails, errorCB);

        }
        , errorCB);
    }
}

// Query the success callback
function returnCityDetails(tx, results) {
    var len = results.rows.length;
    console.log("city detail: " + len + " rows found.");

    if (sLocType == 'weather') {

        $("#weather_city").empty(); //empty the list elements we've placed in the html
        $("#weather_city").append('<option value="-1">Choose a City</option>');
    }
    else if (sLocType == 'garden') {

        $("#garden_city").empty(); //empty the list elements we've placed in the html
        $("#garden_city").append('<option value="-1">Choose a City</option>');
    }

    for (var i = 0; i < len; i++) {
        var city = results.rows.item(i);
        if (sLocType == 'weather') {

            $("#weather_city").append('<option value="' + city.COOP + '">' + city.CITY + '</option>');
        }
        else if (sLocType == 'garden') {
            $("#garden_city").append('<option value="' + city.COOP + '">' + city.CITY + '</option>');
        }

    }

    if (sLocType == 'weather') {

        $("#weather_city").selectmenu('refresh', true);
    }
    else if (sLocType == 'garden') {
        $("#garden_city").selectmenu('refresh', true);
    }


}


function location_getLocation(type) {
    sLocType = type;
   // weather_locationSuccess('');
     navigator.geolocation.getCurrentPosition(weather_locationSuccess, weather_locationError);

}

var mylat = -1;
var mylong = -1;

function weather_locationSuccess(position) {
    var db = window.openDatabase("Garden", "1.0", "Organic Gardening", 200000);
    db.transaction(function queryGardenPlannerList(tx) {

         mylat = position.coords.latitude;
         mylong = position.coords.longitude;

       // mylat = 37.46;
       // mylong = -122.25;
        tx.executeSql('SELECT * from CityState', [], returnAllCitiesForGeoCode, errorCB);
    }
        , errorCB);
}

function weather_locationError(error) {
    alert('Could Not Get Your Location\n' +
           error.message + '\n');
}



function returnAllCitiesForGeoCode(tx, results) {
    var len = results.rows.length;
    console.log("city detail: " + len + " rows found.");

    var cD = -1;
    var cCITY = '';
    var cCOOP = '';
    var cST = '';

    for (var i = 0; i < len; i++) {
        var city = results.rows.item(i);
        var d = calculateDistance(mylat, mylong, city.lat_dec, city.long_dec);

        if (d < cD || cD == -1) {
            console.log(city.CITY + ' - ' + d);
            cD = d;
            cCITY = city.CITY;
            cCOOP = city.COOP;
            cST = city.ST;
        }
    }

    if (cD != -1) {

        //We found the closest station, now lets update the drop downs

        if (sLocType == 'weather') {
            $("#weather_city").empty();
            $("#weather_city").append('<option value="' + cCOOP + '">' + cCITY + '</option>');
            $("#weather_city").selectmenu('refresh', true);

            $("#weather_state").val(cST);
            $("#weather_state").selectmenu('refresh', true);

            loadCityFrostDates(cCOOP);
        }
        else if (sLocType == 'garden') {
            $("#garden_city").empty();
            $("#garden_city").append('<option value="' + cCOOP + '">' + cCITY + '</option>');
            $("#garden_city").selectmenu('refresh', true);

            $("#garden_state").val(cST);
            $("#garden_state").selectmenu('refresh', true);
        }


    }
    else {
        alert('Could not locate the closest station');
    }
}

function calculateDistance(lat1, lon1, lat2, lon2) {

    var R = 6371; // km
    var dLat = (lat2 - lat1).toRad();
    var dLon = (lon2 - lon1).toRad();
    var lat1 = lat1.toRad();
    var lat2 = lat2.toRad();

    var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) +
        Math.sin(dLon / 2) * Math.sin(dLon / 2) * Math.cos(lat1) * Math.cos(lat2);
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
    var d = R * c;

    return (d)
}
