﻿//  ===================  QUERY GARDEN LISTING =====================
var activegardenid = -1;
var activegardenname = 'loading';
var gardenMode = 'list';

function formatDate(value) {
    return value.getMonth() + 1 + "/" + value.getDate() + "/" + value.getYear();
}

function refreshGardenList() {
    activegardenid = -1;
   // var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(queryGardenList, errorCB);
}


function loadGardenList() {
    activegardenid = -1;
    gardenMode = 'list';
   // var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(queryGardenList, errorCB);
}

function toggleGardenListWithDelete() {
    activegardenid = -1;
    if (gardenMode == 'list') {
        gardenMode = 'delete';
    }
    else {
        gardenMode = 'list';
    }
   // var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(queryGardenList, errorCB);
}


function queryGardenList(tx) {
    tx.executeSql('SELECT Gardens.rowid,Gardens.*,CityState.ST,CityState.CITY FROM Gardens INNER JOIN CityState ON CityState.COOP = Gardens.GardenLocation order by GardenName', [], gardensReturned, errorCB);
}

// Query the success callback
function gardensReturned(tx, results) {

    $("#gardenlist").empty(); //empty the list elements we've placed in the html

    var len = results.rows.length;
    console.log("garden table: " + len + " rows found.");
    for (var i = 0; i < len; i++) {
        var garden = results.rows.item(i);

        var sGardenItem = '';
        sGardenItem += '<li><a href="" onclick="navigateGarden(' + garden.rowid + ',\'' + garden.GardenName + '\');"><img src="images/mygardenfolder.png" /><h3>' + garden.GardenName + '</h3><p>' + garden.CITY + ', ' + garden.ST +  '</p></a>';

        if (gardenMode == 'list') {
            sGardenItem += '</li>'
        }
        else {
            sGardenItem += '<a href="" onclick="removeGarden(' + garden.rowid + ');" data-icon="delete" data-theme="a">Delete Garden</a></li>'
        }

        $("#gardenlist").append(sGardenItem);

    }

    $("#gardenlist").listview('refresh'); //must be called if you want the new list elements properly styled
}

function navigateGarden(id, name) {
    //Navigate to Plant Page and Load Its Details
    activegardenid = id;
    activegardenname = name;
    $("#gardenplantlist").empty();

    document.getElementById('garden_header').innerHTML = name
    $.mobile.changePage('#gardenplants');
}


// ==== SAVE GARDEN
function saveGarden() {

    var sError = '';

    if (document.getElementById('garden_state').value == -1) {
        sError += 'Garden State is Required.\n';
    }

    if (document.getElementById('garden_city').value == -1) {
        sError += 'Garden City is Required.\n';
    }

    if (document.getElementById('garden_name').value == '') {
        sError += 'Garden Name is Required\n';
    }

    if (sError == '') {
       // var db = window.openDatabase("Garden", "1.0", "Organic Gardening", 200000);
        db.transaction(saveGardenTX, errorCB, gardenSaved);
    }
    else {
        alert(sError);
    }
}

function saveGardenTX(tx) {
    tx.executeSql('INSERT INTO GARDENS (GardenName, GardenLocation) VALUES ("' + document.getElementById('garden_name').value + '","' + document.getElementById('garden_city').value + '")');
}

function gardenSaved(tx, results) {
    $.mobile.changePage('#gardenpage');
    loadGardenList();
}

//removeGarden
function removeGarden(gardenid) {
  //  var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(function save(tx) {

        tx.executeSql('DELETE FROM GardenPlants where GardenID=' + gardenid);
        tx.executeSql('DELETE FROM Gardens where rowid=' + gardenid);
    }
            , errorCB,
            function saved(tx, results) {
                refreshGardenList();
            }
        );
}



var gardenPlantMode = 'list';

//  ===================  QUERY PLANT LISTING =====================

function refreshGardenPlantList() {
   // var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(queryGardenPlantList, errorCB);
}

function loadGardenPlantList() {
    gardenPlantMode = 'list';
   // var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(queryGardenPlantList, errorCB);
}

function toggleGardenPlantListWithDelete() {
    if (gardenPlantMode == 'list') {
        gardenPlantMode = 'delete';
    }
    else {
        gardenPlantMode = 'list';
    }
   // var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(queryGardenPlantList, errorCB);
}


function queryGardenPlantList(tx) {
    tx.executeSql('SELECT Plants.rowid,Plants.*,GardenPlants.PlantDay,GardenPlants.PlantMonth,GardenPlants.PlantYear, CityState.avg_last_spring, CityState.avg_first_fall FROM GardenPlants INNER JOIN Plants On Plants.PlantID=GardenPlants.PlantID INNER JOIN Gardens on Gardens.rowid=GardenPlants.GardenID INNER JOIN CityState ON CityState.COOP = Gardens.GardenLocation Where GardenPlants.GardenID=' + activegardenid + '  order by PlantName ASC', [], gardenPlantsReturned, errorCB);
    //tx.executeSql('SELECT Plants.*, GardenPlants.PlantMonth, GardenPlants.PlantDay, GardenPlants.PlantYear FROM Plants INNER JOIN GardenPlants ON GardenPlants.PlantID = Plants.PlantID INNER JOIN CityState ON CityState.COOP = Garden WHERE GardenPlants.GardenID=' + activegardenid + ' order by PlantName ASC', [], gardenPlantsReturned, errorCB);
}

// Query the success callback
function gardenPlantsReturned(tx, results) {

    $("#gardenplantlist").empty(); //empty the list elements we've placed in the html

    var len = results.rows.length;
    console.log("garden plant table: " + len + " rows found.");
    for (var i = 0; i < len; i++) {
        var plant = results.rows.item(i);

        var plantitem = '';
        var plantingdates = '';

        if (hasValue(plant.PlantYear)) {
            //Plant is Planted , Get Harvest Information

            var sHarvest = ''

            if (hasValue(plant.FirstHarvestMin) && hasValue(plant.FirstHarvestMax)) {

                var sPlantFirstDay = new Date(plant.PlantMonth + '/' + plant.PlantDay + '/' + plant.PlantYear);
                var sPlantLastDay = new Date(plant.PlantMonth + '/' + plant.PlantDay + '/' + plant.PlantYear);

                sPlantFirstDay.setDate(sPlantFirstDay.getDate() + (parseInt(plant.FirstHarvestMin)));
                sPlantLastDay.setDate(sPlantLastDay.getDate() + (parseInt(plant.FirstHarvestMax)));

                //alert(sPlantFirstDay.toDateString());

                sHarvest += 'Harvest on: ' + formatDate(sPlantFirstDay) + ' to ' + formatDate(sPlantLastDay) + '<br/>';
                plantingdates += '<p>Planted on ' + plant.PlantMonth + '/' + plant.PlantDay + '/' + plant.PlantYear + '<br/>' + sHarvest + '</p></a>';
            }
            else {
                plantingdates += '<p>Planted on ' + plant.PlantMonth + '/' + plant.PlantDay + '/' + plant.PlantYear + '</a>';
            }


            
        }
        else {
            //NOT YET PLANTED, LETS SHOW PLANTING DATES
            if (hasValue(plant.avg_last_spring) && hasValue(plant.avg_first_fall)) {

                var d = new Date();

                if (plant.avg_last_spring == '00/00') {
                    var lastSpringFrost = '00/00';
                }
                else {
                    var lastSpringFrost = new Date(plant.avg_last_spring + '/' + d.getFullYear())
                }

                if (plant.avg_first_fall == '00/00') {
                    var firstFallFrost = '00/00';
                } else {
                    var firstFallFrost = new Date(plant.avg_first_fall + '/' + d.getFullYear())
                }

                var sFrostData = ''

                //var sFrostData = '<h4>Based on your Garden\'s Location, Here are the Best Planting Dates For This Year: </h4>'

                if (hasValue(plant.SpringSowType) && hasValue(plant.SpringSowMin) && hasValue(plant.SpringSowMax)) {
                    if (lastSpringFrost != '00/00') {
                        var sPlantFirstDay = new Date(lastSpringFrost);
                        var sPlantLastDay = new Date(lastSpringFrost);

                        if (plant.SpringSowType == 1) {
                            sPlantFirstDay.setDate(sPlantFirstDay.getDate() + (parseInt(plant.SpringSowMin) * 7));
                            sPlantLastDay.setDate(sPlantLastDay.getDate() + (parseInt(plant.SpringSowMax) * 7));
                        }
                        else if (plant.SpringSowType == 0) {
                            sPlantFirstDay.setDate(sPlantFirstDay.getDate() - (parseInt(plant.SpringSowMax) * 7));
                            sPlantLastDay.setDate(sPlantLastDay.getDate() - (parseInt(plant.SpringSowMin) * 7));
                        }
                        else if (plant.SpringSowType == 2) {
                            sPlantFirstDay.setDate(sPlantFirstDay.getDate() - (parseInt(plant.SpringSowMin) * 7));
                            sPlantLastDay.setDate(sPlantLastDay.getDate() + (parseInt(plant.SpringSowMax) * 7));
                        }
                        sFrostData += 'Spring: ' + formatDate(sPlantFirstDay) + ' to ' + formatDate(sPlantLastDay) + '<br/>';
                    }
                }
                else {
                    //sFrostData += '<p>Spring Planting Dates: Not Available</p>';
                }

                if (hasValue(plant.FallSowType) && hasValue(plant.FallSowMin) && hasValue(plant.FallSowMax)) {
                    if (firstFallFrost != '00/00') {
                        var sPlantFallFirstDay = new Date(firstFallFrost);
                        var sPlantFallLastDay = new Date(firstFallFrost);

                        if (plant.FallSowType == 1) {
                            sPlantFallFirstDay.setDate(sPlantFallFirstDay.getDate() + (parseInt(plant.FallSowMin) * 7));
                            sPlantFallLastDay.setDate(sPlantFallLastDay.getDate() + (parseInt(plant.FallSowMax) * 7));
                        }
                        else if (plant.FallSowType == 0) {
                            sPlantFallFirstDay.setDate(sPlantFallFirstDay.getDate() - (parseInt(plant.FallSowMax) * 7));
                            sPlantFallLastDay.setDate(sPlantFallLastDay.getDate() - (parseInt(plant.FallSowMin) * 7));
                        }
                        else if (plant.FallSowType == 2) {
                            sPlantFallFirstDay.setDate(sPlantFallFirstDay.getDate() - (parseInt(plant.FallSowMin) * 7));
                            sPlantFallLastDay.setDate(sPlantFallLastDay.getDate() + (parseInt(plant.FallSowMax) * 7));
                        }

                        sFrostData += ' Fall: ' + formatDate(sPlantFallFirstDay) + ' to ' + formatDate(sPlantFallLastDay) + '';
                    }
                }
                else {
                    //sFrostData += 'Fall Planting Dates: Not Available</p>';
                }

                // document.getElementById('planner_frostdetail').innerHTML = sFrostData;
            }
            else {
                //document.getElementById('planner_frostdetail').innerHTML = '<h4>Frost Data Unavailable For Your Location</h4>';
            }
            plantingdates += '<p>' + sFrostData + '</p>'
        }

           





        plantitem += '<li><a href="" onclick="navigatePlant(' + plant.PlantID + ');"><img src="plantimages/' + plant.ImageName + '" /><h3>' + plant.PlantName + '</h3>'
        plantitem += plantingdates;
 



        if (gardenPlantMode == 'list') {
            plantitem += '</li>'
        }
        else {
            plantitem += '<a href="" onclick="removePlantFromGarden(' + activegardenid + ',' + plant.PlantID + ');" data-icon="delete" data-theme="a">Delete Plant</a></li>'
        }
        $("#gardenplantlist").append(plantitem);
    }

    $("#gardenplantlist").listview('refresh'); //must be called if you want the new list elements properly styled
}



//removePlantFromGarden
function removePlantFromGarden(gardenid, plantid) {
   // var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(function save(tx) {
        tx.executeSql('DELETE FROM GardenPlants where GardenID=' + gardenid + ' and PlantID=' + plantid);
    }
            , errorCB,
            function saved(tx, results) {
                $.mobile.changePage('#gardenplants');
                refreshGardenPlantList();
            }
        );
}