﻿

// =================================== PLANNER PAGE FUNCTIONS ==========================================

function loadPlannerGardenDropdown() {
    //var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(function queryGardenPlannerList(tx) {
        tx.executeSql('SELECT rowid,* FROM Gardens order by GardenName', [], gardensPlannerReturned, errorCB);
    }
        , errorCB);
}

// Query the success callback
function gardensPlannerReturned(tx, results) {


    $("#planner_gardens").empty(); //empty the list elements we've placed in the html

    $("#planner_gardens").append('<option value="-1" data-placeholder="true">Add to My Garden</option>');

    var len = results.rows.length;
    console.log("planner_garden table: " + len + " rows found.");
    for (var i = 0; i < len; i++) {
        var garden = results.rows.item(i);
        $("#planner_gardens").append('<option value="' + garden.rowid + '">' + garden.GardenName + '</option>');
    }
    $.mobile.selectmenu.prototype.options.hidePlaceholderMenuItems = true;
    $("#planner_gardens").selectmenu('refresh', true);
}



// ==== ADD PLANT TO GARDEN
function addPlantToGarden(GardenID, PlantID) {
   // var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(function save(tx) {
        tx.executeSql('INSERT INTO GardenPlants (GardenID, PlantID) VALUES (' + GardenID + ',' + PlantID + ')');
    }
            , errorCB,
            function saved(tx, results) {
                activegardenid = GardenID;
                $.mobile.changePage('#gardenplants');
            }
        );
}

function setPlantedDate(planteddate, activeplantid, activegardenid) {
    if (isDate(planteddate) || planteddate == '') {
        if (planteddate == '') {
            var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
            db.transaction(function save(tx) {
                tx.executeSql('UPDATE GardenPlants SET PlantDay="", PlantMonth="", PlantYear="" Where GardenID=' + activegardenid + ' and PlantID=' + activeplantid);
            }
                , errorCB,
                function saved(tx, results) {
                    loadPlannerPlantDetails();  //REFRESH THE DETAILS
                }
            );
        }
        else {

            var dateparse = planteddate.split('/');
            var plantyear = +dateparse[2];
            var plantmonth = +dateparse[0];
            var plantday = +dateparse[1];

            var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
            db.transaction(function save(tx) {
                tx.executeSql('UPDATE GardenPlants SET PlantDay="' + plantday + '", PlantMonth="' + plantmonth + '", PlantYear="' + plantyear + '" Where GardenID=' + activegardenid + ' and PlantID=' + activeplantid);
            }
                , errorCB,
                function saved(tx, results) {
                    loadPlannerPlantDetails();  //REFRESH THE DETAILS
                }
            );

        }

    }

    else {
        alert('Please Enter A Valid Date');
    }

}


// === GET PLANT DETAILS

function loadPlannerPlantDetails() {
    //Did we come from a garden or from the browse or planner links
    TogglePlannerDisplay();

    //var db = window.openDatabase("Garden", dbVersion, "Organic Gardening", 200000);
    db.transaction(function queryGardenPlannerList(tx) {
        if (activegardenid == -1) {
            tx.executeSql('SELECT Plants.rowid,Plants.* FROM Plants where Plants.PlantID=' + activeplantid, [], returnPlannerPlantDetails, errorCB);
        }
        else {
            tx.executeSql('SELECT Plants.rowid,Plants.*,GardenPlants.PlantDay,GardenPlants.PlantMonth,GardenPlants.PlantYear, CityState.avg_last_spring, CityState.avg_first_fall FROM GardenPlants INNER JOIN Plants On Plants.PlantID=GardenPlants.PlantID INNER JOIN Gardens on Gardens.rowid=GardenPlants.GardenID INNER JOIN CityState ON CityState.COOP = Gardens.GardenLocation Where GardenPlants.GardenID=' + activegardenid + ' and GardenPlants.PlantID=' + activeplantid, [], returnPlannerPlantDetails, errorCB);
        }

    }
        , errorCB);
}


function TogglePlannerDisplay() {

    if (activegardenid == -1) // no active garden
    {
        $("#planner_differentbtn").show();
        $("#planner_returnbtn").hide();
        $("#planner_addtogarden").show();
        $("#planner_removefromgarden").hide();
        $("#planner_planteddate").hide();


    }
    else {
        $("#planner_differentbtn").hide();
        $("#planner_returnbtn").show();
        $("#planner_addtogarden").hide();
        $("#planner_removefromgarden").show();
        $("#planner_planteddate").show();
    }






}

function parseDate() {
    var split = str.split('-');

    return {
        year: +split[0],
        month: +split[1],
        day: +split[2]
    };
}




function hasValue(v) {
    if (v == null || v == '') {
        return (false);
    }
    else {
        return (true);
    }
}

// Query the success callback
function returnPlannerPlantDetails(tx, results) {
    var len = results.rows.length;
    console.log("plant detail: " + len + " rows found.");
    for (var i = 0; i < len; i++) {
        var plant = results.rows.item(i);
        document.getElementById('planner_plantname').innerHTML = plant.PlantName;

        document.getElementById('planner_plantimage').innerHTML = '<img src="plantimages/' + plant.ImageName + '" />';

        //Build Detail Screen
        var sDP = ''

        if (hasValue(plant.SeedAmt)) { sDP += '<b>Seeds/Plants per 10ft:</b> ' + plant.SeedAmt + '<br />'; }
        if (hasValue(plant.Recommended)) { sDP += '<b>Plants Recommended:</b> Yes' + '<br />'; } else { sDP += '<b>Plants Recommended:</b> No' + '<br />'; }
        if (hasValue(plant.IndoorsorSow)) { sDP += '<b>Start indoors or direct-sow?:</b> ' + plant.IndoorsorSow + '<br />'; }
        if (hasValue(plant.PlantingDepth)) { sDP += '<b>Seed Planting Depth (inches -- 0 means do not cover):</b> ' + plant.PlantingDepth + '<br />'; }
        if (hasValue(plant.DistanceRows)) { sDP += '<b>Distance between plants  (inches):</b> ' + plant.DistanceRows + '<br />'; }
        if (hasValue(plant.RaisedRows)) { sDP += '<b>Raised Rows:</b> Yes' + '<br />'; } else { sDP += '<b>Raised Rows:</b> No' + '<br />'; }
        if (hasValue(plant.RaisedHills)) { sDP += '<b>Raised Hills:</b> Yes' + '<br />'; } else { sDP += '<b>Raised Hills:</b> No' + '<br />'; }
        if (hasValue(plant.ThinningDistance)) { sDP += '<b>Distance between plants after thinning (inches):</b> ' + plant.ThinningDistance + '<br />'; }
        if (hasValue(plant.LSFIndoors)) { sDP += '<b>Time before last spring frost date to begin indoor seedlings (weeks):</b> ' + plant.LSFIndoors + '<br />'; }
        if (hasValue(plant.FirstHarvest)) { sDP += '<b>Time from sowing or transplanting to first expected harvest (days):</b> ' + plant.FirstHarvest + '<br />'; }
        if (hasValue(plant.LastHarvest)) { sDP += '<b>Time from planting to last expected harvest (weeks):</b> ' + plant.LastHarvest + '<br />'; }
        if (hasValue(plant.SpringSow)) { sDP += '<b>When to direct-sow or transplant (spring):</b> ' + plant.SpringSow + '<br />'; }
        if (hasValue(plant.FallSow)) { sDP += '<b>When to direct-sow or transplant (fall):</b> ' + plant.FallSow + '<br />'; }
        if (hasValue(plant.MultipleSow)) { sDP += '<b>Multiple Sowings Recommended:</b> Yes' + '<br />'; } else { sDP += '<b>Multiple Sowings Recommended:</b> No' + '<br />'; }
        if (hasValue(plant.Perennial)) { sDP += '<b>Perennial:</b> ' + plant.Perennial + '<br />'; }
        if (hasValue(plant.Notes)) { sDP += '<b>Notes:</b> ' + plant.Notes + '<br />'; }

        document.getElementById('planner_plantdetail').innerHTML = sDP;

        if (activegardenid != -1) {



            if (hasValue(plant.PlantYear)) {
                document.getElementById('planner_planteddatefield').value = plant.PlantMonth + '/' + plant.PlantDay + '/' + plant.PlantYear;
            }
            else {
                document.getElementById('planner_planteddatefield').value = '';
            }



            if (hasValue(plant.avg_last_spring) && hasValue(plant.avg_first_fall)) {

                var d = new Date();

                if (plant.avg_last_spring == '00/00')
                {
                    var lastSpringFrost = '00/00';
                }
                else
                {
                var lastSpringFrost = new Date(plant.avg_last_spring + '/' + d.getFullYear())
                }

                if (plant.avg_first_fall == '00/00') {
                    var firstFallFrost = '00/00';
                } else {
                    var firstFallFrost = new Date(plant.avg_first_fall + '/' + d.getFullYear())
                }


                var sFrostData = ''

                var sFrostData = '<h4>Based on your Garden\'s Location, Here are the Best Planting Dates For This Year: </h4>'

                if (hasValue(plant.SpringSowType) && hasValue(plant.SpringSowMin) && hasValue(plant.SpringSowMax)) {

                    if (lastSpringFrost != '00/00') {
                        var sPlantFirstDay = new Date(lastSpringFrost);
                        var sPlantLastDay = new Date(lastSpringFrost);

                        if (plant.SpringSowType == 1) {
                            sPlantFirstDay.setDate(sPlantFirstDay.getDate() + (parseInt(plant.SpringSowMin) * 7));
                            sPlantLastDay.setDate(sPlantLastDay.getDate() + (parseInt(plant.SpringSowMax) * 7));
                        }
                        else if (plant.SpringSowType == 0) {
                            sPlantFirstDay.setDate(sPlantFirstDay.getDate() - (parseInt(plant.SpringSowMax) * 7));
                            sPlantLastDay.setDate(sPlantLastDay.getDate() - (parseInt(plant.SpringSowMin) * 7));
                        }
                        else if (plant.SpringSowType == 2) {
                            sPlantFirstDay.setDate(sPlantFirstDay.getDate() - (parseInt(plant.SpringSowMin) * 7));
                            sPlantLastDay.setDate(sPlantLastDay.getDate() + (parseInt(plant.SpringSowMax) * 7));
                        }
                        sFrostData += '<p>Spring Planting Dates: ' + sPlantFirstDay.toDateString() + ' to ' + sPlantLastDay.toDateString() + '</p>';
                    }
                    else {
                        sFrostData += '<p>Spring Planting Dates: Not Available</p>';
                    }
                }
                else {
                    sFrostData += '<p>Spring Planting Dates: Not Available</p>';
                }

                if (hasValue(plant.FallSowType) && hasValue(plant.FallSowMin) && hasValue(plant.FallSowMax)) {

                    if (firstFallFrost != '00/00') {
                        var sPlantFallFirstDay = new Date(firstFallFrost);
                        var sPlantFallLastDay = new Date(firstFallFrost);

                        if (plant.FallSowType == 1) {
                            sPlantFallFirstDay.setDate(sPlantFallFirstDay.getDate() + (parseInt(plant.FallSowMin) * 7));
                            sPlantFallLastDay.setDate(sPlantFallLastDay.getDate() + (parseInt(plant.FallSowMax) * 7));
                        }
                        else if (plant.FallSowType == 0) {
                            sPlantFallFirstDay.setDate(sPlantFallFirstDay.getDate() - (parseInt(plant.FallSowMax) * 7));
                            sPlantFallLastDay.setDate(sPlantFallLastDay.getDate() - (parseInt(plant.FallSowMin) * 7));
                        }
                        else if (plant.FallSowType == 2) {
                            sPlantFallFirstDay.setDate(sPlantFallFirstDay.getDate() - (parseInt(plant.FallSowMin) * 7));
                            sPlantFallLastDay.setDate(sPlantFallLastDay.getDate() + (parseInt(plant.FallSowMax) * 7));
                        }
                        sFrostData += '<p>Fall Planting Dates: ' + sPlantFallFirstDay.toDateString() + ' to ' + sPlantFallLastDay.toDateString() + '</p>';
                    }
                    else {
                        sFrostData += 'Fall Planting Dates: Not Available</p>';
                    }

                }
                else {
                    sFrostData += 'Fall Planting Dates: Not Available</p>';
                }

                document.getElementById('planner_frostdetail').innerHTML = sFrostData;
            }
            else {
                document.getElementById('planner_frostdetail').innerHTML = '<h4>Frost Data Unavailable For Your Location</h4>';
            }



        }
        else {
            document.getElementById('planner_frostdetail').innerHTML = '';
        }



        $.mobile.changePage('#planner');

        //$.mobile.hidePageLoadingMsg();
    }
}


//Checks if a given date string is in
// one of the valid formats:
// a) M/D/YYYY format
// b) M-D-YYYY format
// c) M.D.YYYY format
// d) M_D_YYYY format
function isDate(s) {
    // make sure it is in the expected format
    if (s.search(/^\d{1,2}[\/|\-|\.|_]\d{1,2}[\/|\-|\.|_]\d{4}/g) != 0)
        return false;

    // remove other separators that are not valid with the Date class   
    s = s.replace(/[\-|\.|_]/g, "/");

    // convert it into a date instance
    var dt = new Date(Date.parse(s));

    // check the components of the date
    // since Date instance automatically rolls over each component
    var arrDateParts = s.split("/");
    return (
         dt.getMonth() == arrDateParts[0] - 1 &&
         dt.getDate() == arrDateParts[1] &&
         dt.getFullYear() == arrDateParts[2]
     );
}



